import { IUsersRepository } from '@modules/users/repositories/IUsersRepostory';
import { AppError } from '@shared/error/AppError';
import 'reflect-metadata';
import { inject, injectable } from 'tsyringe';

@injectable()
class FindOneUserUseCase {
    constructor (
        @inject('UsersRepository')
        private usersRepository: IUsersRepository
    ) {}

    async execute(email: string) {
        const userAlreadyExists = await this.usersRepository.findByEmail(email)
        if(!userAlreadyExists) {
            throw new AppError('User doesnt Exists', 404);
        }

        const user = await this.usersRepository.findByEmail(email)
        return user
    }
}



export {FindOneUserUseCase}